#ifndef APPMANAGER_H
#define APPMANAGER_H

#include <QObject>
#include <KWindowSystem>
class AppManagerService;
class AppLauncher;
class WhiteListManager;
class MemoryMonitor;
class AppManager : public QObject
{
    Q_OBJECT
public:
    explicit AppManager(QObject *parent = nullptr);

    Q_INVOKABLE bool LaunchApp(const QString &desktopFile);
    Q_INVOKABLE bool LaunchAppWithArguments(const QString &desktopFile,const QStringList &args);
    Q_INVOKABLE bool LaunchXdgFile(const QString &desktopFile, const QString &fileName);
    Q_INVOKABLE bool LaunchDefaultAppWithUrl(const QString &url);
    Q_INVOKABLE void SetPowerSavingModeEnable(bool isPowerSaving);
    Q_INVOKABLE bool AddToWhiteList(const QString &desktopFile, const QString &option);
    Q_INVOKABLE bool RemoveFromWhiteList(const QString &desktopFile, const QString &option);
    Q_INVOKABLE bool ActiveProcessByWid(const uint &wid);
    Q_INVOKABLE QStringList WhiteListsOfApp(const QString &desktopFile);
    Q_INVOKABLE QString AppDesktopFileNameByPid(qint64 pid);
    Q_INVOKABLE QString AppDesktopFileNameByWid(qint64 wid);

#if 0
    Q_INVOKABLE QList<uint> RunningApplications();
#endif

private:
    AppManagerService *m_service;
    AppLauncher *m_appLauncher;
    WhiteListManager *m_whiteListManager;
#if 0
    MemoryMonitor *m_memMonitor;
#endif
};

#endif // APPMANAGER_H
