#ifndef APPLAUNCHERDAEMON_H
#define APPLAUNCHERDAEMON_H

#include <QObject>

class QSocketNotifier;
class QDBusInterface;

///
/// \brief The AppLauncherDaemon class
///
class AppLauncherDaemon : public QObject
{
    Q_OBJECT
public:
    explicit AppLauncherDaemon(QObject *parent = nullptr);

    // Unix signal handlers.
    static void chldSignalHandler(int unused);
    static void quitSignalHandler(int unused);

    static void setupUnixSignalHandlers();

public Q_SLOTS:
     // Qt signal handlers.
     void handleSigChld();
     void handleQuitSig();

private Q_SLOTS:
     void prepareForShutdown(bool shutDown);

Q_SIGNALS:
     void childProcessFinished(quint32 pid);
     void aboutToQuitAppManager();

private:
    static int s_sigChldFd[2];
    static int s_sigQuitFd[2];

    QSocketNotifier *m_snChld;
    QSocketNotifier *m_snQuit;

    QDBusInterface *m_sessionmanagerInterface;

    quint32 m_logoutInhibitCookie;
};

#endif // APPLAUNCHERDAEMON_H
