#include "misc.h"
#include <QDir>
#include <QFile>
#include <QJsonDocument>
#include <QDebug>

namespace utils {

Misc::Misc(QObject *parent) : QObject(parent)
{

}

bool utils::Misc::ensurePathExists(const QString &path)
{
    QDir dir(path);
    if (dir.exists(path)) {
        return true;
    }

    if (!dir.mkdir(path)) {
        qWarning() << "mkdir failed: " << path;
        return false;
    }

    return true;
}

bool Misc::ensureFileExists(const QString &fileName)
{
    QFile file(fileName);
    if (file.exists()) {
        return true;
    }

    if (!file.open(QIODevice::ReadWrite | QIODevice::Append)) {
        qWarning() << "open file failed: " << fileName;
        return false;
    }
    return true;
}

QJsonObject Misc::readJsonFromFile(const QString &fileName)
{
    QFile file(fileName);
    if (!file.open(QIODevice::ReadOnly)) {
        qWarning() << "open json file failed: " << fileName;
        return QJsonObject();
    }

    QJsonDocument jdc(QJsonDocument::fromJson(file.readAll()));
    return jdc.object();
}

void Misc::writeJsonFoFile(const QJsonObject &obj, const QString &fileName)
{
    QFile jsonFile(fileName);
    if (!jsonFile.open(QIODevice::WriteOnly)) {
        qWarning() << "open json file failed: " << fileName;
        return;
    }
    QJsonDocument jdoc(obj);
    jsonFile.write(jdoc.toJson());
    jsonFile.flush();
}

} // namespace utils

